'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

/**
 * Author   : roy
 * Date     : 2017-08-08  11:48
 * Describe :
 */

var defaultHandleTrack = function defaultHandleTrack(trackData, controlArg) {
  console.warn('统计实现要自己写啦，handleTrack: (trackData, controlArg) => {}');
};

var create = exports.create = function create() {
  var trackConfig = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
  var _trackConfig$commonPa = trackConfig.commonParams,
      commonParams = _trackConfig$commonPa === undefined ? {} : _trackConfig$commonPa,
      _trackConfig$handleTr = trackConfig.handleTrack,
      handleTrack = _trackConfig$handleTr === undefined ? defaultHandleTrack : _trackConfig$handleTr,
      _trackConfig$showLog = trackConfig.showLog,
      showLog = _trackConfig$showLog === undefined ? true : _trackConfig$showLog,
      _trackConfig$basePara = trackConfig.baseParams,
      baseParams = _trackConfig$basePara === undefined ? {} : _trackConfig$basePara;


  var handleTrackSeccess = function handleTrackSeccess() {
    if (showLog) {
      console.log('统计发送成功');
    }
  };

  return function () {
    var _ref = _asyncToGenerator(regeneratorRuntime.mark(function _callee(trackData, controlArg) {
      return regeneratorRuntime.wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              trackData = _extends({}, promoteValue(baseParams, {}), promoteValue(commonParams, {}), trackData);
              controlArg = _extends({
                showLog: showLog
              }, promoteValue(controlArg, {}));
              // 发送统计请求
              _context.next = 4;
              return handleTrack(trackData, controlArg).then(handleTrackSeccess).catch(console.warn);

            case 4:
            case 'end':
              return _context.stop();
          }
        }
      }, _callee, undefined);
    }));

    return function (_x2, _x3) {
      return _ref.apply(this, arguments);
    };
  }();
};

var promoteValue = exports.promoteValue = function promoteValue() {
  var target = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
  var funcArgs = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : [];

  if ((typeof target === 'undefined' ? 'undefined' : _typeof(target)) === 'object') {
    return target;
  }
  if (typeof target === 'function') {
    return target.apply(undefined, _toConsumableArray(funcArgs));
  }
};

var createWrap = exports.createWrap = function createWrap(targetFunc) {
  return function () {
    for (var _len = arguments.length, wrapArgs = Array(_len), _key = 0; _key < _len; _key++) {
      wrapArgs[_key] = arguments[_key];
    }

    return function (func) {
      return function () {
        for (var _len2 = arguments.length, funcArgs = Array(_len2), _key2 = 0; _key2 < _len2; _key2++) {
          funcArgs[_key2] = arguments[_key2];
        }

        var trackArgs = wrapArgs.map(function (arg) {
          return promoteValue(arg, funcArgs);
        });
        targetFunc.apply(undefined, _toConsumableArray(trackArgs)).catch(function (e) {});
        return func.apply(undefined, funcArgs);
      };
    };
  };
};

exports.default = {
  create: create,
  createWrap: createWrap
};
