/**
 * Author   : roy
 * Date     : 2017-08-08  11:48
 * Describe :
 */

const defaultHandleTrack = (trackData, controlArg) => {
  console.warn('统计实现要自己写啦，handleTrack: (trackData, controlArg) => {}')
}

export const create = (trackConfig = {}) => {
  const {
    commonParams = {},
    handleTrack = defaultHandleTrack,
    showLog = true,
    baseParams = {}
  } = trackConfig

  const handleTrackSeccess = () => {
    if (showLog) {
      console.log('统计发送成功')
    }
  }

  return async(trackData, controlArg) => {
    trackData = {
      ...promoteValue(baseParams, {}),
      ...promoteValue(commonParams, {}),
      ...trackData
    }
    controlArg = {
      showLog,
      ...promoteValue(controlArg, {})
    }
    // 发送统计请求
    await handleTrack(trackData, controlArg)
      .then(handleTrackSeccess)
      .catch(console.warn)
  }
}

export const promoteValue = (target = {}, funcArgs = []) => {
  if (typeof target === 'object') {
    return target
  }
  if (typeof target === 'function') {
    return target(...funcArgs)
  }
}

export const createWrap = targetFunc => {
  return (...wrapArgs) => {
    return (func) => {
      return (...funcArgs) => {
        let trackArgs = wrapArgs.map(arg => {
          return promoteValue(arg, funcArgs)
        })
        targetFunc(...trackArgs).catch(e => {})
        return func(...funcArgs)
      }
    }
  }
}

export default {
  create,
  createWrap
}